require 'swf'
require 'nscrm3d'
require 'm3dapi'

local fps = 30
local frate = math.floor(1000 / fps)
local m3d
-- PC̃XybNɎM̂lLɂ邱ƁB
local highspec = false

swf.init(nil, frate)

-- P̋Np
function NSCOM_main()
  NSCOM_init()
  NSCOM_camera()
end


function NSCOM_m3dinit()
  local sp = NSPopInt()
  local movie = swf.create(sp):withOpen("nscrm3d.swf"):withLoop(false):withShow():withCurrentFrame(1)
  movie:setInterval(frate)
  m3dapi.init(movie)
end


function NSCOM_init()
  local file = NSPopStr()
  NSExec("bg white,1")
  local movie = swf.create():withOpen("nscrm3d.swf"):withLoop(false):withShow():withCurrentFrame(1)
  m3d = nscrm3d.new(movie)
  m3d:lm3d(0, file)
  m3d:m3drender()
end


function NSCOM_camera()
  if highspec then
    m3d:m3drender(nscrm3d.Render.Every)
  end
  
  local normalActions = {
    LEFT = {x = -10},
    RIGHT = {x = 10},
    UP = {y = -10},
    DOWN = {y = 10},
    PAGEUP = {zoom = 1},
    PAGEDOWN = {zoom = -1},
  }
  local ctrlActions = {
    LEFT = {panAngle = 10},
    RIGHT = {panAngle = -10},
    UP = {tiltAngle = 10},
    DOWN = {tiltAngle = -10},
    PAGEUP = {focus = 10},
    PAGEDOWN = {focus = -10},
  }
  
  repeat
    local l,r,w,ld,rd = NSGetClick()
    if rd then break end
    local args
    if NSGetKey("ESC") then
      NSEnd()
    else
      local keys = {"LEFT", "RIGHT", "UP", "DOWN", "PAGEUP", "PAGEDOWN"}
      local ctrl = NSGetKey("CTRL")
      local downed
      for _,key in ipairs(keys) do
        if NSGetKey(key) then
          downed = key
          break
        end
      end
      if downed then
        args = ctrl and ctrlActions[downed] or normalActions[downed]
      end
    end
    if args then
      if m3d:m3dcameraadd(args) then
        m3d:m3dtrace(true)
        if not highspec then
          m3d:m3drender(nscrm3d.Render.Force)
          NSInvalidate(0, 0, 639, 479)
          NSUpdate()
        end
      end
    end
    if highspec then
      local timer = NSTimer()
      NSInvalidate(0, 0, 639, 479)
      NSUpdate()
      local gap = NSTimer() - timer
      if gap < frate then
        NSSleep(frate - gap)
      end
    else
      NSSleep(frate)
    end
  until NSDoEvents()
end


function NSCOM_motion()
  local file = NSPopStr()
  local everyRender = false
  if NSCheckComma() then
    NSPopComma()
    everyRender = NSPopInt() ~= 0
  end
  m3d:m3dmotionload(0, file)
  
  m3d:m3drender(everyRender and nscrm3d.Render.Every or nscrm3d.Render.Force)
  if not m3d:m3dmotionplay(0) then
    m3d:m3dtrace(true)
    NSInvalidate(0, 0, 639, 479)
    NSUpdate()
    NSOkBox("VMDĐsI", "")
    NSClick()
    NSEnd()
  end

  local playing = true

  repeat
    local l,r,w,ld,rd = NSGetClick()
    if rd then break end
    if NSGetKey("ESC") then NSEnd() end
    if NSGetKey("SPACE") then
      while NSGetKey("SPACE") do
        if NSDoEvents() then return end
        NSSleep(1)
      end
      if playing then
        m3d:m3dmotionstop(0)
        playing = false
      else
        m3d:m3dmotionplay(0)
        playing = true
      end
    end
    local timer = NSTimer()
    NSInvalidate(0, 0, 639, 479)
    NSUpdate()
    local gap = NSTimer() - timer
    if gap < frate then
      NSSleep(frate - gap)
    end
  until NSDoEvents()
end
