require 'lunit'

local nscrm3d = require 'nscrm3d'

-- mock
local orgNSExec = NSExec
local luasubs = {}
NSExec = function(str)
  table.insert(luasubs, str:sub(#("luasub ")+1))
end

-- target
local m3dapi = require 'm3dapi'
NSExec = orgNSExec

module( "m3dapi_test", package.seeall, lunit.testcase )


function setup()
end


function teardown()
end


function test_defined()
  for _, name in ipairs(luasubs) do
    assert_not_equal("new", name)
    assert_equal("function", type(nscrm3d[name]))
    assert_equal("function", type(_G['NSCOM_' .. name]))
  end
end
